tigase.xmpp.impl

## Class Message

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.impl.Message

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, XMPPImplIfc, XMPPPacketFilterIfc, XMPPPreprocessorIfc, XMPPProcessorIfc

      public class Message
      extends AnnotatedXMPPProcessor
      implements XMPPProcessorIfc, XMPPPreprocessorIfc, XMPPPacketFilterIfc

  Message forwarder class. Forwards `Message` packet to it's destination address. Created: Tue Feb 21 15:49:08 2006
  Version:
    $Rev$
  Author:
    Artur Hefczyc

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `ELEM_NAME`
    `protected static String` | `XMLNS`

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Message()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `filter(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results)`
    `List<XMPPResourceConnection>` | `getConnectionsForMessageDelivery(XMPPResourceConnection session)` Method returns list of XMPPResourceConnections to which message should be delivered for session passes as parameter if message was sent to bare JID
    `Set<JID>` | `getJIDsForMessageDelivery(XMPPResourceConnection session)` Method returns list of JIDs to which message should be delivered for session passes as parameter if message was sent to bare JID
    `boolean` | `hasConnectionForMessageDelivery(XMPPResourceConnection session)` Method returns true if there is at least one XMPPResourceConnection which is allowed to receive message for XMPPResourceConnection
    `void` | `init(Map<String,Object> settings)` Method `init` is called just after the plugin has been loaded into memory.
    `boolean` | `preProcess(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)` Performs pre-processing of `packet`.
    `void` | `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `id, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentThreadsPerQueue, getComponentInfo, getInstance, getStatistics, isSupporting, supElements, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, getStatistics, id, isSupporting, supDiscoFeatures, supElementNamePaths, supElements, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Field Detail

    - #### ELEM_NAME

          protected static final String ELEM_NAME

      See Also:
        Constant Field Values

    - #### XMLNS

          protected static final String XMLNS

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Message

          public Message()

  - ### Method Detail

    - #### init

          public void init(Map<String,Object> settings)
                    throws TigaseDBException

      Description copied from interface: `XMPPImplIfc`
      Method `init` is called just after the plugin has been loaded into memory. The idea behind this is to allow it to initialize or check the database. This might be especially useful for plugins which want to have a database access via non-standard stored procedures or need schema upgrade.
      Specified by:
        `init` in interface `XMPPImplIfc`
      Overrides:
        `init` in class `XMPPProcessor`
      Parameters:
        `settings` - is a Map with initial processor settings from the configuration file.
      Throws:
        `TigaseDBException`

    - #### filter

          public void filter(Packet packet,
                             XMPPResourceConnection session,
                             NonAuthUserRepository repo,
                             Queue<Packet> results)

      Specified by:
        `filter` in interface `XMPPPacketFilterIfc`

    - #### process

          public void process(Packet packet,
                              XMPPResourceConnection session,
                              NonAuthUserRepository repo,
                              Queue<Packet> results,
                              Map<String,Object> settings)
                       throws XMPPException

      Specified by:
        `process` in interface `XMPPProcessorIfc`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
      Throws:
        `XMPPException`

    - #### preProcess

          public boolean preProcess(Packet packet,
                                    XMPPResourceConnection session,
                                    NonAuthUserRepository repo,
                                    Queue<Packet> results,
                                    Map<String,Object> settings)

      Description copied from interface: `XMPPPreprocessorIfc`
      Performs pre-processing of `packet`. Intention for the pre-processors is to allow them for packet blocking.
      Specified by:
        `preProcess` in interface `XMPPPreprocessorIfc`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
      Returns:
        the pre-processing result; if the value is ‘true’ then the packet is blocked and no further processing is performed.

    - #### getConnectionsForMessageDelivery

          public List<XMPPResourceConnection> getConnectionsForMessageDelivery(XMPPResourceConnection session)
                                                                        throws NotAuthorizedException

      Method returns list of XMPPResourceConnections to which message should be delivered for session passes as parameter if message was sent to bare JID
      Parameters:
        `session` -
      Returns:
      Throws:
        `NotAuthorizedException`

    - #### getJIDsForMessageDelivery

          public Set<JID> getJIDsForMessageDelivery(XMPPResourceConnection session)
                                             throws NotAuthorizedException

      Method returns list of JIDs to which message should be delivered for session passes as parameter if message was sent to bare JID
      Parameters:
        `session` -
      Returns:
      Throws:
        `NotAuthorizedException`

    - #### hasConnectionForMessageDelivery

          public boolean hasConnectionForMessageDelivery(XMPPResourceConnection session)

      Method returns true if there is at least one XMPPResourceConnection which is allowed to receive message for XMPPResourceConnection
      Parameters:
        `session` -
      Returns:

Copyright © 2022 "Tigase, Inc.". All rights reserved.